/*
 * Aipo is a groupware program developed by TOWN, Inc.
 * Copyright (C) 2004-2015 TOWN, Inc.
 * http://www.aipo.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.aipo.social.opensocial.service;

import org.apache.shindig.protocol.Operation;
import org.apache.shindig.protocol.RequestItem;
import org.apache.shindig.protocol.Service;

import com.google.inject.Inject;
import com.google.inject.name.Named;

/**
 * RPC/REST handler for Aipo API
 */
@Service(name = "aipo")
public class AipoHandler {

  private final String version;

  private final String apiVersion;

  @Inject
  public AipoHandler(@Named("aipo.version") String version,@Named("aipo.apiVersion") String apiVersion) {
    this.version = version;
    this.apiVersion = apiVersion;
  }

  @Operation(httpMethods = "GET", path = "/version")
  public String version(RequestItem request) {
    return version;
  }

  @Operation(httpMethods = "GET", path = "/apiVersion")
  public String apiVersion(RequestItem request) {
    return apiVersion;
  }
}
